Subject: Re: [PATCH net-next] mctp i2c: notify user space on TX failure

From: Jakub Kicinski <[email-masked]>
Date: Thu, 14 Nov 2024 07:02:35 -0800

On Thu, 14 Nov 2024 14:48:57 +0800 Jeremy Kerr wrote:
> > routing isn't really my forte, TBH, what eats the error so that it
> > doesn't come out of mctp_local_output() ? Do you use qdiscs on top
> > of the MCTP devices?  
> 
> There are no qdiscs involved at this stage, as we need to preserve
> packet ordering in most cases. The route output functions will end up
> in a dev_queue_xmit, so any tx error would have been decoupled from the
> route output at that stage.

Ah, it's the driver eating the errors, it puts the packet on a local
queue and returns OK no matter what. The I2C transfer happens from 
a thread.

I wonder if there is precedent, let's ask CAN experts.

Mark, MCTP would like to report errors from the drivers all the way 
to the socket. Do CAN drivers do something along these lines?